''' <summary>
''' Example 5
''' Manages the Person data entry form
''' </summary>
Public Class GenericMethodExample

#Region " Properties"
    Private PersonList As New List(Of Person)
#End Region

#Region " Form Events"
    Private Sub GenericDictionaryExample_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        InitializeGrid()
    End Sub
#End Region

#Region " Control Events"
    Private Sub AddButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddButton.Click
        ProcessAdd()
    End Sub

    Private Sub SaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveButton.Click
        For Each individual As Person In PersonList
            MyBase.Save(individual)
        Next
    End Sub

#End Region

#Region " Private Methods"

#Region " InitializeGrid"
    ''' <summary>
    ''' Sets up the grid
    ''' </summary>
    Private Sub InitializeGrid()
        ' Set up the grid
        Dim currentIndex As Integer
        currentIndex = NameGrid.Columns.Add("FirstName", "First Name")
        currentIndex = NameGrid.Columns.Add("LastName", "Last Name")
        currentIndex = NameGrid.Columns.Add("Phone", "Phone")
        NameGrid.Columns(currentIndex).AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
    End Sub
#End Region

#Region " ProcessAdd"
    ''' <summary>
    ''' Adds a person to the List
    ''' </summary>
    Private Sub ProcessAdd()
        ' Then add the new one
        ' Create the person
        Dim newPerson As New Person
        With newPerson
            .LastName = LastNameTextBox.Text
            .FirstName = FirstNameTextBox.Text
            .Phone = PhoneTextBox.Text
        End With

        ' Add the person to the collection
        PersonList.Add(newPerson)

        ' Populate the grid
        PopulateGrid()

        ' Clear the form for the next entry
        FirstNameTextBox.Text = String.Empty
        LastNameTextBox.Text = String.Empty
        PhoneTextBox.Text = String.Empty
    End Sub
#End Region

#Region " PopulateGrid"
    ''' <summary>
    ''' Populates the grid
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub PopulateGrid()
        ' Clear the grid
        NameGrid.Rows.Clear()

        ' Repopulate the list so it is sorted
        Dim rowIndex As Integer
        For Each individual As Person In PersonList
            rowIndex = NameGrid.Rows.Add()
            NameGrid.Item("FirstName", rowIndex).Value = individual.FirstName
            NameGrid.Item("LastName", rowIndex).Value = individual.LastName
            NameGrid.Item("Phone", rowIndex).Value = individual.Phone
        Next
    End Sub
#End Region

#End Region

End Class
