''' <summary>
''' Example 5
''' Manages the Task data entry form
''' </summary>
Public Class GenericMethodExample2

#Region " Properties"
    Private TaskList As New List(Of Task)
#End Region

#Region " Form Events"
    Private Sub GenericDictionaryExample_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        InitializeGrid()
    End Sub
#End Region

#Region " Control Events"
    Private Sub AddButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddButton.Click
        ProcessAdd()
    End Sub

    Private Sub SaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveButton.Click
        For Each item As Task In TaskList
            MyBase.Save(item)
        Next
    End Sub

#End Region

#Region " Private Methods"

#Region " InitializeGrid"
    ''' <summary>
    ''' Sets up the grid
    ''' </summary>
    Private Sub InitializeGrid()
        ' Set up the grid
        Dim currentIndex As Integer
        currentIndex = TaskGrid.Columns.Add("TaskName", "Task")
        currentIndex = TaskGrid.Columns.Add("Description", "Description")
        TaskGrid.Columns(currentIndex).AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
    End Sub
#End Region

#Region " ProcessAdd"
    ''' <summary>
    ''' Adds a task to the List
    ''' </summary>
    Private Sub ProcessAdd()
        ' Then add the new one
        ' Create the person
        Dim newTask As New Task
        With newTask
            .TaskName = TaskNameTextBox.Text
            .Description = DescriptionTextBox.Text
        End With

        ' Add the person to the collection
        TaskList.Add(newTask)

        ' Sort the list on task name
        TaskList.Sort(New PropertyComparer(Of Task)("TaskName", SortOrder.Ascending))

        ' Populate the grid
        PopulateGrid()

        ' Clear the form for the next entry
        TaskNameTextBox.Text = String.Empty
        DescriptionTextBox.Text = String.Empty
    End Sub
#End Region

#Region " PopulateGrid"
    ''' <summary>
    ''' Populates the grid
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub PopulateGrid()
        ' Clear the grid
        TaskGrid.Rows.Clear()

        ' Repopulate the list so it is sorted
        Dim rowIndex As Integer
        For Each item As Task In TaskList
            rowIndex = TaskGrid.Rows.Add()
            TaskGrid.Item("TaskName", rowIndex).Value = item.TaskName
            TaskGrid.Item("Description", rowIndex).Value = item.Description
        Next
    End Sub
#End Region

#End Region

End Class
