''' <summary>
''' Example 3
''' Demonstrates using a generic SortedList instead of 
''' sorting the generic List
''' </summary>
Public Class SortedListExample

#Region " Properties"
    Private NameList As New SortedList(Of String, String)
#End Region

#Region " Control Events"
    Private Sub AddButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddButton.Click
        ProcessAdd()
    End Sub
#End Region

#Region " Private Methods"

#Region " ProcessAdd"
    ''' <summary>
    ''' Adds a name to the list
    ''' </summary>
    Private Sub ProcessAdd()
        If NameList.ContainsKey(NameTextBox.Text) Then
            MessageBox.Show("The entered item is already on the list")
        Else
            NameList.Add(NameTextBox.Text, NameTextBox.Text)
            NameTextBox.Text = String.Empty

            NamesListBox.DisplayMember = "Value"
            NamesListBox.DataSource = New BindingSource(NameList, Nothing)
        End If
    End Sub
#End Region

#End Region

End Class