Imports System.Reflection

Public Class StartupForm

#Region " Form Events"
    Private Sub StartupForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SetEventHandlers(Me)
    End Sub

#End Region

#Region " Private Methods"

#Region " ProcessClick"
    ''' <summary>
    ''' Show the form associated with the clicked button
    ''' </summary>
    Private Sub ProcessClick(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim currentButton As Button = DirectCast(sender, Button)

        If currentButton.Tag IsNot Nothing Then
            Dim formName As String = "GenericsProject." & currentButton.Tag.ToString
            Dim currentAssembly As [Assembly] = Assembly.GetExecutingAssembly()

            ' Define the appropriate class
            Dim oType As Type = currentAssembly.GetType(formName)

            ' Create an instance of the form and show it,
            ' Passing in the parameters as needed
            Dim frm As Form
            frm = CType(Activator.CreateInstance(oType), Form)

            frm.ShowDialog()
        End If
    End Sub
#End Region

#Region " SetEventHandlers"
    Private Sub SetEventHandlers(ByVal container As Control)
        For Each ctrl As Control In container.Controls
            If TypeOf ctrl Is Button Then
                AddHandler ctrl.Click, AddressOf ProcessClick
            End If
        Next
    End Sub
#End Region

#End Region

End Class